
/*

        The Scrabble Companion                  v. 0.1.0b
        20 April 1999                           Programmer: Chris Street

*/

#include <conio.h>              /* For console output goodies */
#include <ctype.h>              /* For tolower() */
#include <dos.h>                /* For DPMI real mode interrupt simulation */
#include <iostream.h>
#include <keys.h>               /* For key mnemonics */
#include <math.h>               /* For the standard deviation stuff */
#include <pc.h>                 /* For getkey() */
#include <stdio.h>              /* For file operations */
#include <stdlib.h>             /* For many different operations (qsort!) */
#include <string.h>             /* String stuff, of course! */
#include <time.h>               /* For timing facilities */

#include "scrab.h"

extern bool use_feature;

const int bonuses[15][15]=
      {
       {30,0,0,2,0,0,0,30,0,0,0,2,0,0,30},
       {0,20,0,0,0,3,0,0,0,3,0,0,0,20,0},
       {0,0,20,0,0,0,2,0,2,0,0,0,20,0,0},
       {2,0,0,20,0,0,0,2,0,0,0,20,0,0,2},
       {0,0,0,0,20,0,0,0,0,0,20,0,0,0,0},
       {0,3,0,0,0,3,0,0,0,3,0,0,0,3,0},
       {0,0,2,0,0,0,2,0,2,0,0,0,2,0,0},
       {30,0,0,2,0,0,0,20,0,0,0,2,0,0,30},
       {0,0,2,0,0,0,2,0,2,0,0,0,2,0,0},
       {0,3,0,0,0,3,0,0,0,3,0,0,0,3,0},
       {0,0,0,0,20,0,0,0,0,0,20,0,0,0,0},
       {2,0,0,20,0,0,0,2,0,0,0,20,0,0,2},
       {0,0,20,0,0,0,2,0,2,0,0,0,20,0,0},
       {0,20,0,0,0,3,0,0,0,3,0,0,0,20,0},
       {30,0,0,2,0,0,0,30,0,0,0,2,0,0,30},
      };

char board[15][15];
int show_blanks[15][15],two_letter_words[26][26];
int setrck=0,firstmenu=1,rck[7]={0,0,0,0,0,0,0},*lettersleft,max_anagrams=250;
int puzzle=0;

#define         nmoves          (scrabble_board.n_moves())
#define         WORD(x)         (scrabble_dictionary.report_word(scrabble_board.report_move(x)->which_word))
#define         COL(x)          (scrabble_board.report_move(x)->column)
#define         ROW(x)          (scrabble_board.report_move(x)->row)
#define         ACROSS(x)       (scrabble_board.report_move(x)->across)
#define         SCORE(x)        (scrabble_board.report_move(x)->score)
#define         EQUITY(x)       float(scrabble_board.report_move(x)->equity/10.)
#define         EQUITYI(x)      (scrabble_board.report_move(x)->equity)

SBoard scrabble_board(0);
Rack scrabble_rack;
Dictionary scrabble_dictionary(200000);
Well scrabble_well;

int attrib_square(int x,int y);
void display_board();
void make_window(int x1,int x2,int y1,int y2,int back,int fore);
int confirm();
void help_window();
void display_letters(int i);
void show_rack();
void set_board();
void clear_board();
void play_game();
int user_rack(int *rack);
int set_on_board(char *word,int row,int column,bool direction,int color,int *rack);
int move_menu(int *rack,int blanks,int is_fish);
void init_board();
void find_first_moves(int *rack,int blanks,int is_fish);
void find_moves(int *rack,int blanks,int is_fish);


int attrib_square(int x,int y)
/* Returns the attribute which a square on the board should be printed in */
{
      if (x==15 || y==15) return 0;
      switch (bonuses[x][y])
      {
       case 0:  return 7 << 4;
       case 2:  return 3 << 4;
       case 3:  return 1 << 4;
       case 20: return 5 << 4;
       case 30: return 4 << 4;
      }
}

void display_board()
/* Redraws the Scrabble board */
{
 int e,f;
 for (e=0;e<15;++e)
 {
     gotoxy(1,e+1);
     for (f=0;f<15;++f)
     {
      if (board[e][f]=='?')
      {
        textattr(attrib_square(e,f));
        putch(32);
        putch(32);
      }
      else
      {
          if (show_blanks[e][f])
              textattr(attrib_square(e,f)+12);
          else
              textattr(attrib_square(e,f));
          putch(32);
          putch((int)board[e][f]-32);
      }
     }
    }
 return;
}

void make_window(int x1,int x2,int y1,int y2,int back,int fore)
/* Low-level (and slow, but that's not the point) routine to draw a simple,
   frill-less window on the screen          */
{
 int e,f;
 gotoxy(x1+1,y1);
 textattr((back<<4)+fore);
 for (e=x1+1;e<x2;e++)
  putch(205);
 gotoxy(x1+1,y2);
 for (e=x1+1;e<x2;e++)
  putch(205);
 gotoxy(x1,y1); putch(201);
 gotoxy(x2,y1); putch(187);
 gotoxy(x1,y2); putch(200);
 gotoxy(x2,y2); putch(188);
 for (e=y1+1;e<y2;e++)
 {
   gotoxy(x1,e); putch(186);
   gotoxy(x2,e); putch(186);
 }
 for (e=y1+1;e<y2;e++)
 {
  gotoxy(x1+1,e);
  for (f=x1+1;f<x2;f++)
   putch(32);
 }
}

int confirm()
/* Yes-or-no user prompt, returns true for yes, false for no */
{
 int ik=0;
 make_window(32,78,1,5,0,7);
 textattr(12);
 gotoxy(45,3);
 cputs("Are you sure? (y/n)");
 while (ik!='y' && ik!='n')
       ik=tolower(getkey());
 return (ik=='y');
}

void help_window()
/* Redraws the current menu window */
{
 make_window(32,78,1,5,0,7);
 gotoxy(35,2);
 cputs(firstmenu ? "F1: Set Board" : "F6: Letters/Key");
 gotoxy(35,3);
 cputs(firstmenu ? "F2: Set Rack" : "F7: Find Fish Moves");
 gotoxy(35,4);
 cputs(firstmenu ? "F3: Find Moves" : "F8: Play Game");
 gotoxy(55,2);
 cputs(firstmenu ? "F4: Clear Board" : "F9: Test Feature");
 gotoxy(55,3);
 cputs(firstmenu ? "F5: Next Menu" : "");
 gotoxy(55,4);
 cputs("ESC: Quit");
}

void display_letters(int i)
/* Is called by a number of functions to display the letter key. If i==-1,
   the key is erased. If i==0, the letter key is displayed in the lower
   right window, which is completely redrawn. If i==1, the key is drawn
   and the function waits for the user to press a key before continuing.
   If i==2, the letter key is refreshed */
{
 int e,f;
 char s[2];
 if (i==-1)
 {
    make_window(32,78,6,24,0,0);
    make_window(32,78,7,24,0,7);
    return;
 }
 if (i!=2) make_window(32,78,6,24,0,7);
 textattr(7);
 s[0]='A';
 s[1]=0;
 for (e=0;e<3;++e)
     for (f=e*9;f<(e*9)+9;++f)
     {
      gotoxy(36+13*e,7+(f-e*9));
      cprintf("%s (%d,%d,%d)  ",(f==26) ? "Blank" : s,letter_dist[f],(f==26) ? 0 : letter_val[f],*(lettersleft+f));
      ++s[0];
     }
 gotoxy(35,17);
 textattr(9);
 cputs("The first number is  the total number of");
 gotoxy(35,18);
 cputs("that letter, the second its unaugmented");
 gotoxy(34,19);
 cputs("point value and the third a count of those");
 gotoxy(40,20);
 cputs("letters remaining to  be used.");
 textattr(3);
 gotoxy(34,22);
 cputs("\333\333 Double Letter");
 textattr(1);
 gotoxy(61,22);
 cputs("\333\333 Triple Letter");
 textattr(5);
 gotoxy(34,23);
 cputs("\333\333 Double Word");
 textattr(4);
 gotoxy(61,23);
 cputs("\333\333 Triple Word");
 if (i==1)
 {
    getkey();
    make_window(32,78,6,24,0,0);
    make_window(32,78,7,24,0,7);
 }
}

void show_rack()
/* Redraws the lower left (rack) window */
{
 int e;
 make_window(2,30,16,24,0,7);
 if (setrck==0)
 {
  gotoxy(7,18);
  cputs("*** No Rack Set ***");
 }
 else
 {
  gotoxy(7,16);
  cputs("Current rack:");
  textattr(15 << 4);
  gotoxy(8,18);
  putch(' ');
  for (e=0;e<setrck;++e)
  {
        if (rck[e]=='?')
           putch(rck[e]);
        else
           putch(rck[e]-32);
        putch(' ');
  }
 }
}


void set_board()
/* The tile-setting function */
{
 int ik,x=7,y=7,e;
 display_letters(0);
 make_window(32,78,1,5,0,7);
 textattr(2);
 gotoxy(48,1);
 cputs(" * Press ESC when finished * ");
 textattr(7);
 gotoxy(35,2);
 cputs("Arrow keys:                    move cursor");
 gotoxy(35,3);
 cputs("Letter:  set a letter (* or ? for a blank)");
 gotoxy(35,4);
 cputs("Backspace:           delete a letter/blank");
 while (1) {
       textattr(attrib_square(x,y));
       gotoxy(((x+1)<<1)-1,y+1);
       putch('*');
       ik=getkey();
       if (ik==K_Escape)
          break;
       if (ik==K_Right && x!=14)
       {
        gotoxy(((x+1)<<1)-1,y+1);
        putch(' ');
        ++x;
       }
       if (ik==K_Down && y!=14)
       {
        gotoxy(((x+1)<<1)-1,y+1);
        putch(' ');
        ++y;
       }
       if (ik==K_Left && x)
       {
        gotoxy(((x+1)<<1)-1,y+1);
        putch(' ');
        --x;
       }
       if (ik==K_Up && y)
       {
        gotoxy(((x+1)<<1)-1,y+1);
        putch(' ');
        --y;
       }
       if (ik==K_BackSpace)
       {
        if (show_blanks[y][x])
           ++*(lettersleft+26);
        else
            if (board[y][x]>='a' && board[y][x]<='z')
               ++*(lettersleft+board[y][x]-'a');
        board[y][x]='?';
        show_blanks[y][x]=0;
        gotoxy(((x+1)<<1),y+1);
        putch(' ');
       }
       if (ik=='*' || ik=='?')
       {
        if (*(lettersleft+26)) {
        gotoxy(32,5);
        textattr(12);
        cputs("Type the letter you want the blank to represent");
        ik=getkey();
        if (ik>='A' && ik<='Z') ik+=32;
        if (ik>='a' && ik<='z') {
         --*(lettersleft+26);
         show_blanks[y][x]=1;
        }
        textattr(7);
        gotoxy(33,5);
        for (e=33;e<78;e++)
            putch(205);
        gotoxy(32,5); putch(200);
        gotoxy(78,5); putch(188);
        textattr(attrib_square(x,y)+12);
        }
       }
       if (ik>='A' && ik<='Z') ik+=32;
       if (ik>='a' && ik<='z')
       {
        if (board[y][x]!='?' && *(lettersleft+ik-'a'))
           if (show_blanks[y][x]) {
              show_blanks[y][x]=0;
              ++*(lettersleft+26);
           }
           else
               ++*(lettersleft+board[y][x]-'a');
        if (*(lettersleft+ik-'a') || (!*(lettersleft+ik-'a') && show_blanks[y][x])) {
        board[y][x]=(char)ik;
        gotoxy(((x+1)<<1),y+1);
        putch(ik-32);
        if (!show_blanks[y][x])
           --*(lettersleft+ik-'a');
        }
       }
       display_letters(2);
 }
 textattr(attrib_square(x,y));
 gotoxy(((x+1)<<1)-1,y+1);
 putch(' ');
 display_letters(-1);
 help_window();
}

void clear_board()
/* Sweeps all tiles off the Scrabble board (rather rudely!) and steals all
   tiles in your rack, returning them to the well. Asks for confirmation
   first, though. */
{
 int e,f;
 if (confirm())
 {
  init_board();
  display_board();
  setrck=0;
  for (e=0;e<7;++e)
      rck[e]=0;
 }
 help_window();
 show_rack();
}

int user_rack(int *rack)
/* Allows the user to set tiles in the Scrabble rack */
{
 int e,n,at=0,ik,ok,co=0;
 display_letters(0);
 make_window(2,30,16,24,0,7);
 make_window(32,78,1,5,0,7);
 textattr(7);
 gotoxy(35,2);
 cputs("Arrow keys:                    move cursor");
 gotoxy(35,3);
 cputs("Letter:  set a letter (* or ? for a blank)");
 gotoxy(35,4);
 cputs("Backspace:           delete a letter/blank");
 gotoxy(3,17);
 cputs("Please give me my letters");
 gotoxy(3,18);
 cputs("(* or ? for a blank)   ");
 gotoxy(3,19);
 cputs("Press <ENTER> when finished");
 textattr(15<<4);
 for (e=0;e<7;++e)
  {
   gotoxy(8+(e<<1),21);
   if (e<setrck)
      if (rck[e]=='?')
         putch(rck[e]);
      else
          putch(rck[e]-32);
   else
      putch(32);
  }
  textattr(15);
  while (1) {
        gotoxy(7+(at<<1),21);
        putch(26);
        ik=getkey();
        if (co)
        {
              gotoxy(8,23);
              cputs("                  ");
              co=0;
        }
        if (ik==K_Right && at<7 && at<setrck)
        {
         if (at!=6) {
         gotoxy(7+(at<<1),21);
         putch(' ');
         ++at;
         }
        }
        if (ik==K_BackSpace && at!=setrck)
        {
         if (rck[at]=='?')
            ++*(lettersleft+26);
         else
             if (rck[at]>='a' && rck[at]<='z')
                ++*(lettersleft+rck[at]-'a');
         for (e=at+1;e<setrck;++e)
             rck[e-1]=rck[e];
         if (setrck != 7)
             for (e=setrck;e<7;++e)
                 rck[e]=0;
         setrck--;
         textattr(15<<4);
         for (e=0;e<7;++e)
         {
          gotoxy(8+(e<<1),21);
          if (e<setrck)
                if (rck[e]>='a' && rck[e]<='z')
                   putch(rck[e]-32);
                else
                   putch('?');
          else
              putch(32);
         }
         textattr(15);
        }
        if (ik==K_Left && at>0)
        {
         gotoxy(7+(at<<1),21);
         putch(' ');
         --at;
        }
        if (ik>='A' && ik<='Z') ik+=32;
        if (ik=='*') ik='?';
        if ((ik>='a' && ik<='z') || ik=='?')
        {
          ok=0;
          if (ik=='?')
              ok=*(lettersleft+26);
          else
              ok=*(lettersleft+ik-'a');
          if (ok) {
             if (at!=setrck)
                if (rck[at]!='?')
                    ++*(lettersleft+rck[at]-'a');
                else
                    ++*(lettersleft+26);
             rck[at]=ik;
             textattr(15<<4);
             gotoxy(8+(at<<1),21);
             if (ik!='?')
             {
                --*(lettersleft+ik-'a');
                putch(ik-32);
             }
             else
             {
                --*(lettersleft+26);
                putch('?');
             }
             textattr(15);
             if (at==setrck)
                {
                 gotoxy(7+(at<<1),21);
                 putch(' ');
                 ++setrck;
                 if (setrck!=7) ++at;
                 }
             }
             else
             {
              gotoxy(8,23);
              textattr((15<<4)+4);
              cprintf("No more '%c's left",ik);
              co=1;
              textattr(15);
             }
        }
        if (ik==K_Return)
        {
         break;
        }
        display_letters(2);
        textattr(15);
  }
 for (e=0;e<26;++e)
     rack[e]=0;
 n=0;
 for (e=0;e<setrck;++e)
 {
     if (rck[e]=='?')
        ++n;
     rack[rck[e]-'a']++;
 }
 show_rack();
 help_window();
 display_letters(-1);
 return n;
}

void test_feature() {
  int e,f,g=0,m,k,rack[27],games[3]={0,0,0},tot_scores[2]={0,0},move=0,pass=0,score[2];
  bool who_first=true,player;
  Rack rack1, rack2;

  make_window(32,78,7,24,0,7);
  while (!kbhit()) {

  score[0]=0;
  score[1]=0;
  init_board();
  display_board();
  setrck=0;
  for (e=0;e<7;++e)
      rck[e]=0;
  scrabble_board.dump_board();
  scrabble_well.refill_well();
  rack1.dump_rack();
  rack2.dump_rack();
  rack1.fill_from_well(&scrabble_well);
  rack2.fill_from_well(&scrabble_well);
  player=who_first;
  do {
        use_feature=player;
        if (player) {
                rack1.copy_rack(rack);
                scrabble_board.find_moves(&rack1, &scrabble_dictionary, &scrabble_well);
        }
        else {
                rack2.copy_rack(rack);
                scrabble_board.find_moves(&rack2, &scrabble_dictionary, &scrabble_well);
        }
        m=scrabble_board.n_moves();
        if (m!=1) {
                int f,i,j;
                i=0;
                j=0;
                while (scrabble_board.report_move(i)->row==999)
                        i++;
                if (player)
                        score[0]+=scrabble_board.report_move(i)->score;
                else
                        score[1]+=scrabble_board.report_move(i)->score;
                gotoxy(41,24);
                textattr(7);
                cprintf("Score: %d pts. - %d pts. ",score[0],score[1]);
                if (scrabble_board.report_move(i)->column==999)
                        if (player)
                                rack1.exchange_tiles(&scrabble_well);
                        else
                                rack2.exchange_tiles(&scrabble_well);
                else {
                        if (player)
                                scrabble_board.move_set(i, &scrabble_dictionary, &rack1);
                        else
                                scrabble_board.move_set(i, &scrabble_dictionary, &rack2);
                        set_on_board(WORD(i),ROW(i),COL(i),ACROSS(i),2,rack);
                        if (player)
                                rack1.fill_from_well(&scrabble_well);
                        else
                                rack2.fill_from_well(&scrabble_well);
                }
                display_board();
        }
        player=!player;
        if (m==1)
                ++pass;
        else
                pass=0;
        if (scrabble_well.is_well_empty() && (!rack1.n_tiles() || !rack2.n_tiles()))
                break;
  } while (pass!=2);

  for (e=0;e<26;++e) {
        score[0]-=letter_val[e]*rack1.how_many(e);
        score[1]-=letter_val[e]*rack2.how_many(e);
  }
  if (score[0]>score[1])
        ++games[0];
  else if (score[1]>score[0])
        ++games[1];
  else
        ++games[2];
  tot_scores[0]+=score[0];
  tot_scores[1]+=score[1];
  textattr(14);
  gotoxy(37,11);
  cprintf("Games played total:               %d",g+1);
  gotoxy(37,12);
  cprintf("Games won by strategy player:     %d",games[0]);
  gotoxy(37,13);
  cprintf("Games won by non-strategy player: %d",games[1]);
  gotoxy(37,14);
  cprintf("Games ending in a tie:            %d",games[2]);
  gotoxy(37,15);
  cprintf("Average score/game (strategy):  %3.2f",float(tot_scores[0])/(g+1));
  gotoxy(37,16);
  cprintf("Average score/game (non-str.):  %3.2f",float(tot_scores[1])/(g+1));
  who_first=!who_first;         // Give both players equal chance to start

  ++g;

  }

  textattr(7);
  show_rack();
  use_feature=true;
  return;
}

void play_game() {

  int e,f,m,k,rack[27],move=0,score=0;

  struct moves {
        int r;
        int c;
        int s;
        bool b;

  } mvs[128];

/*
  make_window(32,78,7,24,0,7);
  init_board();
  display_board();
*/
  setrck=0;
  for (e=0;e<7;++e)
      rck[e]=0;
  scrabble_board.dump_board();
  scrabble_well.refill_well();
  scrabble_rack.dump_rack();
  scrabble_rack.fill_from_well(&scrabble_well);
  do {
        scrabble_rack.copy_rack(rack);
        scrabble_board.find_moves(&scrabble_rack, &scrabble_dictionary, &scrabble_well);
        m=scrabble_board.n_moves();
        if (m!=1) {
                int f,i,j;
                i=0;
                j=0;
                mvs[move].r = scrabble_board.report_move(i)->row;
                mvs[move].c = scrabble_board.report_move(i)->column;
                mvs[move].s = scrabble_board.report_move(i)->score;
                while (scrabble_board.report_move(i)->row==999)
                        i++;
                score+=scrabble_board.report_move(i)->score;
/*
                if (move==16) {
                        movetext(33,9,78,23,33,8);
                        gotoxy(33,23);
                }
                else
                        gotoxy(33,8+move);
                textattr(7);
*/
                if (scrabble_board.report_move(i)->is_bingo)
                        mvs[move].b = true;
/*
                if (SCORE(i)>=100)
                        textattr(5);
                if (SCORE(i)>=75 && !scrabble_board.report_move(i)->is_bingo)
                        textattr(2);
*/
                if (scrabble_board.report_move(i)->column==999) {
//                        textattr(7);
                        cprintf("Exchange        \263           \263 ");
                        for (e=0,j=0;e<26;++e) {
                                if (scrabble_rack.how_many(e) && e!=0 && e!=4 && e!=8 && e!=13 && e!=17 && e!=18 && e!=19) {
                                        ++j;
                                        cprintf("%c",'a'+e);
                                }
                                for (f=1;f<scrabble_rack.how_many(e);++f) {
                                        ++j;
                                        cprintf("%c",'a'+e);
                                }
                        }
                        for (e=j;e<7;++e)
                                cputs(" ");
                        cputs("\263");
                }
                else {
                        cprintf("%-15s \263%2d,%c %-6s\263%3d %-3s\263",WORD(i),ROW(i),char(COL(i)+'A'),ACROSS(i) ? "across" : "down",SCORE(i),SCORE(i)==1 ? "pt." : "pts.");
                }
                for (e=0;e<27;++e)
                       for (f=0;f<scrabble_rack.how_many(e);++f,++j)
                              if (e<26)
                                      cprintf("%c",'a'+e);
                              else
                                      cputs("?");
                for (e=j;e<7;++e)
                        cputs(" ");
                if (move!=16)
                        ++move;
                if (scrabble_board.report_move(i)->column==999)
                        scrabble_rack.exchange_tiles(&scrabble_well);
                else {
                        scrabble_board.move_set(i, &scrabble_dictionary, &scrabble_rack);
                        scrabble_rack.fill_from_well(&scrabble_well);
                        set_on_board(WORD(i),ROW(i),COL(i),ACROSS(i),2,rack);
                }
                display_board();
                gotoxy(41,24);
                textattr(13);
                cprintf("Total score: %d pts.",score);
        }
  } while (m!=1);
  if (move==16) {
        movetext(33,9,78,23,33,8);
        gotoxy(33,23);
  }
  else
        gotoxy(33,8+move);

  textattr(7);

  cprintf("Unplayed Tiles  \263 ");
  m=0;
  k=0;
  for (e=0;e<27;++e)
        for (f=0;f<scrabble_rack.how_many(e);++f,++k)
                if (e<26) {
                        cprintf("%c",'a'+e);
                        m+=letter_val[e];
                }
                else
                        cputs("?");
  for (e=k;e<7;++e)
        cputs(" ");
  cprintf("   \263%3d %-3s\263       ",-m,(m==1) ? "pt. " : "pts.");
  score-=m;
  gotoxy(41,24);
  textattr(3);
  cprintf("Final score: %d pts.",score);

  show_rack();
}

int set_on_board(char *word,int row,int column,bool direction,int color,int *rack)
/* Displays a word on the board. Especially handy for move_menu(). */
{
 int r=row,c=column,cr=0,cc=0,e,f,nb=0;
 if (!direction) cr=1; else cc=1;
 for (e=0;e<strlen(word);++e,c+=cc,r+=cr)
 {
  textattr(attrib_square(c,r)+9);
  gotoxy(((c+1)<<1),r+1);
  if (scrabble_board.blank(r,c))
        show_blanks[r][c]=1;
  if (board[r][c]=='?')
  {
   if (color)
      putch(word[e]-32);
   if (color==2)
   {
    if (!rack[word[e]-'a'])
    {
     for (f=0;f<setrck;++f)
         if (rck[f]=='?')
            { rck[f]=0; ++nb; }
    }
    else
    {
      --rack[word[e]-'a'];
      for (f=0;f<setrck;++f)
         if (rck[f]==word[e])
            rck[f]=0;
    }
    board[r][c]=word[e];
   }
   if (!color)
      putch(' ');
   }
  }
  return nb;
}

int move_menu(int *rack,int blanks,int is_fish)
/* Calls the appropriate move-finding function for the current board/rack
   configuration, and then displays all the moves found in a neat scroll
   table in the lower right window */
{
 int top=0,select=0,e,f,g,ik;
 make_window(32,78,7,24,0,7);
 if (setrck==0)
 {
  gotoxy(38,10);
  cputs("It would be nice if I had a rack.");
  return blanks;
 }
 gotoxy(49,10);
 cputs("Hmm...");
 e=1;
 for (f=0;f<15;++f)
     for (g=0;g<15;++g)
         if (board[f][g]!='?')
            e=0;
 if (e)
    find_first_moves(rack,blanks,is_fish);
 else
    find_moves(rack,blanks,is_fish);
 if (nmoves==0)
 {
  gotoxy(34,10);
  cputs("You're in trouble! I can't think of a move!");
  return blanks;
 }
 make_window(32,78,7,24,0,7);
 make_window(32,78,1,5,0,7);
 textattr(2);
 gotoxy(34,7);
 cprintf(" I found %d moves ",nmoves);
 textattr(7);
 gotoxy(35,2);
 cputs("Arrows, PgUp/Dn, Home/End    navigate list");
 gotoxy(35,3);
 cputs("Enter:               set word on the board");
 gotoxy(35,4);
 cputs("Press <ESC> when you are finished.");
 while (1) {
  for (e=top;e<=top+15 && e<nmoves;++e)
  {
   gotoxy(33,(e-top)+8);
   if (e==select)
        textattr(15<<4);
   else
        textattr(7);
   if (ROW(e)==999)
      cprintf("Pass           \263            \263  0 pts. \263     ");
   else if (COL(e)==999)
      cprintf("Exchange       \263            \263  0 pts. \263     ");
   else
      cprintf("%-15s\263%2d, %c %-6s\263%3d %-5s\263%s%+3.1f",WORD(e),ROW(e),char(COL(e)+'A'),ACROSS(e) ? "across" : "down",SCORE(e),SCORE(e)==1 ? "pt. " : "pts.",(EQUITYI(e) < 100 ? " " : ""),EQUITY(e));
  }
   if (ROW(e)!=999 && COL(e)!=999)
    set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),1,rack);
   ik=getkey();
   if (ik==K_Down && select<nmoves-1)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    select++;
    if (select>top+15)
       ++top;
   }
   if (ik==K_Up && select)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    select--;
    if (select<top)
       --top;
   }
   if (ik==K_Return)
   {
    if (ROW(e)!=999 && COL(e)!=999) {
    scrabble_board.move_set(select, &scrabble_dictionary, &scrabble_rack);
    blanks-=set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),2,rack);
    setrck=0;
    for (f=0;f<26;++f)
        for (g=0;g<rack[f];++g)
        {
         rck[setrck]='a'+f;
         ++setrck;
        }
    for (f=0;f<blanks;++f)
        {
         rck[setrck]='?';
         ++setrck;
        }
    for (e=0;e<setrck;++e)
        if (rck[e]==0)
           for (f=e+1;f<=setrck;++f)
               rck[f-1]=rck[f];
    }
    make_window(32,78,7,24,0,7);
    display_board();
    show_rack();
    help_window();
    return blanks;
   }
   if (ik==K_Home)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    select=top=0;
   }
   if (ik==K_PageDown)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    top+=15;
    select+=15;
    if (top>=nmoves-16)
       top=nmoves-16;
    if (top<0) top=0;
    if (select>=nmoves)
       select=nmoves-1;
   }
   if (ik==K_PageUp)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    top-=15;
    select-=15;
    if (top<0)
       top=0;
    if (select<0)
       select=0;
   }
   if (ik==K_End)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    top=nmoves-16;
    select=nmoves-1;
   }
   if (ik==K_Escape)
   {
    if (ROW(e)!=999 && COL(e)!=999)
     set_on_board(WORD(select),ROW(select),COL(select),ACROSS(select),0,rack);
    make_window(32,78,7,24,0,7);
    help_window();
    display_board();
    return blanks;
   }
 }
}

void init_board()
/* Returns all letters on the board back to the well. */
{
 int e,f;
 for (e=0;e<15;++e)
     for (f=0;f<15;++f)
     {
         board[e][f]='?';
         show_blanks[e][f]=0;
     }
 lettersleft=(int *)malloc(27*sizeof(int));
 memcpy(lettersleft,letter_dist,27*sizeof(int));
}

void find_first_moves(int *rack,int blanks,int is_fish)
{
        int e,f;
        scrabble_board.dump_board();
        scrabble_rack.dump_rack();
        scrabble_well.refill_well();
        for (e=0;e<26;++e)
            for (f=0;f<rack[e];++f) {
                scrabble_rack.add_letter(e+'a');
                scrabble_well.remove_from_well(e+'a');
            }
        for (e=0;e<blanks;++e) {
                scrabble_rack.add_letter('?');
                scrabble_well.remove_from_well('?');
        }
        if (!is_fish)
                scrabble_board.find_moves(&scrabble_rack, &scrabble_dictionary, &scrabble_well);
        else
                scrabble_board.find_fish_moves(&scrabble_rack, &scrabble_dictionary, &scrabble_well);
        return;
}

void find_moves(int *rack,int blanks,int is_fish)
{
        int e,f;      
        scrabble_board.dump_board();
        scrabble_well.refill_well();
        for (e=0;e<15;++e)
                for (f=0;f<15;++f) {
                        scrabble_board.set_on_board(e,f,board[e][f],show_blanks[e][f]);
                        if (!show_blanks[e][f] && board[e][f]!='?')
                           scrabble_well.remove_from_well(board[e][f]);
                        else
                           scrabble_well.remove_from_well('?');
                }
        scrabble_rack.dump_rack();
        for (e=0;e<26;++e)
            for (f=0;f<rack[e];++f) {
                scrabble_rack.add_letter(e+'a');
                scrabble_well.remove_from_well(e+'a');
            }
        for (e=0;e<blanks;++e) {
                scrabble_rack.add_letter('?');
                scrabble_well.remove_from_well('?');
        }
        if (!is_fish)
                scrabble_board.find_moves(&scrabble_rack, &scrabble_dictionary, &scrabble_well);
        else
                scrabble_board.find_fish_moves(&scrabble_rack, &scrabble_dictionary, &scrabble_well);
        return;
}

int main(int argc,char **argv)
/* The program entry point; sets the ball rolling. */
{
 int e,blanks,ik,rack[26]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
 union REGS r;
 r.x.ax=3;
 int86(0x10,&r,&r);     /* Make sure we've the correct video mode... */
 srandom(time(NULL));
 puts("Scrabble Companion\t\t\t\tby Chris Street");
 puts("v 0.1.0\341  20 April 1999.\n");
 puts("Loading vocabulary list...");
 if (!scrabble_dictionary.load_dictionary("word.lst"))
        cout << "Error! I couldn't find the dictionary \"word.lst\"!";

 init_board();

 intensevideo();
 clrscr();
 display_board();
 textattr(15);
 make_window(32,78,7,24,0,7);
 show_rack();
 help_window();
 while (1)
 {
  ik=getkey();
  if (ik==K_Escape)
     if (confirm())
        break;
     else
        help_window();
  if (ik==K_F1)
     set_board();
  if (ik==K_F2)
     blanks=user_rack(rack);
  if (ik==K_F3)
     blanks=move_menu(rack,blanks,0);
  if (ik==K_F4)
     clear_board();
  if (ik==K_F5)
  {
   firstmenu=abs(firstmenu-1);
   help_window();
  }
  if (ik==K_F6)
     display_letters(1);
  if (ik==K_F7)
     blanks=move_menu(rack,blanks,1);
  if (ik==K_F8)
     play_game();
  if (ik==K_F9)
     test_feature();
 }
 textattr(7);
 clrscr();
 blinkvideo();

 free(board);
 free(lettersleft);
 return 0;
}

